camera = {}

camera.layers = {}
camera.scaleX = 1
camera.scaleY = 1
camera.rotation = 0
camera.position = Vector.new(0,0)

function camera:set()
  love.graphics.push()

  love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
  love.graphics.translate(-self.position.x +love.graphics.getWidth()/2, -self.position.y+love.graphics.getHeight()/2)
end

function camera:unset()
  love.graphics.pop()
end

function camera:move(dx, dy)
  self.position.x = self.position.x + (dx or 0)
  self.position.y = self.position.y + (dy or 0)
end

function camera:rotate(dr)
  self.rotation = self.rotation + dr
end

function camera:scale(sx, sy)
  sx = sx or 1
  self.scaleX = self.scaleX * sx
  self.scaleY = self.scaleY * (sy or sx)
end

function camera:setPosition(x, y)
  self.position.x = x or self.position.x
  self.position.y = y or self.position.y
end

function camera:setScale(sx, sy)
  self.scaleX = sx or self.scaleX
  self.scaleY = sy or self.scaleY
end
function camera:newLayer(scale, func)
  table.insert(self.layers, { draw = func, scale = scale })
  table.sort(self.layers, function(a, b) return a.scale < b.scale end)
end