local anim8 = require("anim8")

gameObject = {}
gameObject.__index = gameObject

gameObject.position = Vector.new(0,0)
gameObject.velocity = Vector.new(0,0)
gameObject.isStatic = true
gameObject.hasAnimation = false
gameObject.image = {}
gameObject.boundaries = {}
gameObject.speed = 0


function gameObject.new(myPosition, myVelocity, mySpeed, myAnimation, myStatic, myImage)
	gameObject:setBoundaries(myPosition, love.graphics.newImage(myImage))

	return setmetatable({
	position = myPosition,
	velocity = myVelocity,
	speed = mySpeed,
	isStatic = myStatic,
	hasAnimation = myAnimation,
	image = love.graphics.newImage(myImage)}, gameObject)
end

function gameObject:draw()
	love.graphics.draw(self.image, math.floor(self.position.x-self.image:getWidth()/2), math.floor(self.position.y-self.image:getHeight()/2))
end

function gameObject:update(dt)
	return
end

function gameObject:setBoundaries(myPosition, image)
	gameObject.boundaries = {myPosition.x, myPosition.y,image:getWidth(),image:getHeight()}
end


setmetatable(gameObject,
{__call = function(_, ...) return gameObject.new(...) end})