mainCharacter = {}
mainCharacter.__index = mainCharacter
mainCharacter.mydestination = Vector.new(0,0)

function mainCharacter.new(myPosition, myImage)
	
	return setmetatable(gameObject.new(myPosition, Vector.new(0,0), 4, true, false, myImage), mainCharacter)
	
end

function mainCharacter:getCameraPosition()

	return Vector.new(math.floor(self.position.x), math.floor(self.position.y))
end

function mainCharacter:draw()
	love.graphics.draw(self.image, math.floor(self.position.x-self.image:getWidth()/2), math.floor(self.position.y-self.image:getHeight()/2))
end

function mainCharacter:printInfo()
	print(self.position.x)
	print(self.position.y)
	print(self.mydestination.x)
	print(self.mydestination.y)
	print(math.floor(self.position.x))
	print(math.floor(self.position.y))
	print(math.floor(self.position.x-self.image:getWidth()/2))
	print(math.floor(self.position.y-self.image:getHeight()/2))

end





function mainCharacter:update(dt)
	--[[if #loveframes.collisions > 0 then
        return
    end--]]
    local distanceTraveled = Vector.new(0,0)

    --[[if(love.keyboard.isDown("up","down","left","right")) then --if a key is pressed then move the object in that direction and override any previous velocities
        if love.keyboard.isDown("up") then
            distanceTraveled.y = distanceTraveled.y - self.speed
        end
        if love.keyboard.isDown("down") then
            distanceTraveled.y = distanceTraveled.y + self.speed
        end
        if love.keyboard.isDown("left") then
            distanceTraveled.x = distanceTraveled.x - self.speed
        end
        if love.keyboard.isDown("right") then
            distanceTraveled.x = distanceTraveled.x + self.speed
        end
        distanceTraveled = distanceTraveled:normalize()
        distanceTraveled = distanceTraveled * self.speed
        self.position = self.position + distanceTraveled
        camera.position = self:getCameraPosition()
        self.velocity = Vector.new(0,0)--]]
    if love.mouse.isDown("l") then --if the mouse buton is held down the main character will run to that position, updating every frame
        self.mydestination = Vector.new(love.mouse.getX(),love.mouse.getY()) + camera.position - Vector.new(love.graphics.getWidth()/2,love.graphics.getHeight()/2)

        
        self.velocity = self.mydestination - self.position
        self.velocity:normalize()
        if (self.mydestination.x - 5 > self.position.x or  self.position.x > self.mydestination.x + 5) or 
            (self.mydestination.y - 5 > self.position.y or self.position.y > self.mydestination.y + 5) then

            --I want the velocity of the object to be projected onto the "wall" and that projection will become my new velocity
            distanceTraveled = self.velocity * self.speed
            self.position = self.position + distanceTraveled
            camera.position = self:getCameraPosition()
        else
            self.velocity = Vector.new(0,0)
            self.mydestination = Vector.new(0,0)
        end
    else
    	if (self.mydestination. x - 5 > self.position.x or  self.position.x > self.mydestination.x + 5) or 
            (self.mydestination.y - 5 > self.position.y or self.position.y > self.mydestination.y + 5) then

            --I want the velocity of the object to be projected onto the "wall" and that projection will become my new velocity
            distanceTraveled = self.velocity * self.speed
            self.position = self.position + distanceTraveled
            camera.position = self:getCameraPosition()
        else
            self.velocity = Vector.new(0,0)
            self.mydestination = Vector.new(0,0)
        end
    end
end


setmetatable(mainCharacter,
{__call = function(_, ...) return mainCharacter.new(...) end})